<script setup lang="ts">
import { ref, onMounted, watch } from "vue";
import { useQuasar } from "quasar";

import { checkPermission } from "@/utils/permissions";
import { useResultDataStore } from "@/modules/07_insignia/storeResult";
import { useCounterMixin } from "@/stores/mixin";
import http from "@/plugins/http";
import config from "@/app.config";

/** import Type*/
import type { QTableProps, QInput } from "quasar";
import type {
  OptionData,
  DataPerson,
  DataRecord,
} from "@/modules/07_insignia/interface/index/Main";
import type { ResponseRound } from "@/modules/07_insignia/interface/response/Main";

/** import Components*/
import DialogHeader from "@/components/DialogHeader.vue";
import Dialogbody from "@/modules/07_insignia/components/3_result/DialogReceive_Return.vue"; //รับ-คืนเครื่องราชฯ
import DialogForm from "@/modules/07_insignia/components/3_result/DialogResults.vue"; //บันทึกผล
import fileUploadview from "../components/3_result/TabDocuments.vue";
import PopupPersonal from "@/components/Dialogs/PopupPersonalNew.vue";

/** use*/
const $q = useQuasar();
const DataStore = useResultDataStore();
const mixin = useCounterMixin();
const {
  date2Thai,
  dialogConfirm,
  showLoader,
  hideLoader,
  messageError,
  success,
  onSearchDataTable,
} = mixin;

/** ตัวแปร*/
const tab = ref<string>(""); //Tab รายการ
const selectRound = ref<string>(""); //รอบการเสนอขอ
const selectRoundOption = ref<OptionData[]>([]); //รายการรอบการเสนอขอ
const modal = ref<boolean>(false); //popup บันทึกผล
const action = ref<string>(""); //ประเภทแก่ไข,เพิ่ม
const personId = ref<string>(); //id คนที่ต้องการ
const profileType = ref<string>(""); //ประเภทข้ารายกาช
const fileResult = ref<any>(null); //ไฟล์บันทึกผลการได้รับพระราชทานเครื่องราชอิสริยาภรณ์
const fileinvoice = ref<any>(null); //ไฟล์บันทึกผลการจ่ายใบกำกับ
const loadView = ref<boolean>(false); //แสดง ข้อมูล
const insigniaTypeOption = ref<OptionData[]>([]); //ข้อมูลประเภทเครื่องราช
const insigniaTypeFilter = ref<OptionData[]>([]); //รายการตัวเลือกประเภทเครื่องราช
const filterInvoice = ref<OptionData[]>(DataStore.invoiceTypeop); //รายการตัวเลือกใบกำกับ
const filterEmployee = ref<OptionData[]>(DataStore.employeeClassOps); //รายการตัวเลือกสถานะภาพ
const ModalDialog = ref<boolean>(false); //popup รับ-คืนเครื่องราชฯ
const dateCheckReceive = ref<string>(); //วันที่รับ
const dateCheckReturn = ref<string>(); //วันที่คืน
const dataModal = ref<DataPerson>(); //ช้อมูลที่ต้องการ

/** ข้อมูล Tabla*/
const rowsMain = ref<DataRecord[]>([]);
const filterRef = ref<QInput>();
const filter = ref<string>("");
const columns = ref<QTableProps["columns"]>([
  {
    name: "no",
    align: "left",
    label: "ลำดับ",
    field: "no",
    sortable: false,
  },
  {
    name: "status",
    align: "left",
    label: "สถานะ",
    field: "status",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },

  {
    name: "citizenId",
    align: "left",
    label: "เลขประจำตัวประชาชน",
    field: "citizenId",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "name",
    align: "left",
    label: "ชื่อ-นามสกุล",
    field: "name",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "position",
    align: "left",
    label: "ตำแหน่ง",
    field: "position",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  // {
  //   name: "employeeType",
  //   align: "left",
  //   label: "ประเภทตำแหน่ง",
  //   field: "employeeType",
  //   sortable: true,
  //   sort: (a: string, b: string) =>
  //     a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  // },
  {
    name: "type",
    align: "left",
    label: "เครื่องราชฯ",
    field: "type",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "dateReceive",
    align: "left",
    label: "วันที่ได้รับพระราชทาน",
    field: "dateReceive",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "date",
    align: "left",
    label: "วันที่ในราชกิจนุเบกษา",
    field: "date",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "volumeNo",
    align: "left",
    label: "เล่มที่ในราชกิจนุเบกษา",
    field: "volumeNo",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "section",
    align: "left",
    label: "ตอนที่ในราชกิจนุเบกษา",
    field: "section",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },

  {
    name: "page",
    align: "left",
    label: "หน้าที่ในราชกิจนุเบกษา",
    field: "page",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "number",
    align: "left",
    label: "ลำดับที่ในราชกิจจานุเบกษา",
    field: "number",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "vatnumber",
    align: "left",
    label: "หมายเลขใบกำกับ",
    field: "vatnumber",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "datepay",
    align: "left",
    label: "วันที่จ่ายใบกำกับฯ",
    field: "datepay",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "typepay",
    align: "left",
    label: "รูปแบบการจ่าย",
    field: "typepay",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "address",
    align: "left",
    label: "ที่อยู่ที่จ่าย",
    field: "address",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
]);
const visibleColumns = ref<String[]>([
  "action",
  "no",
  "status",
  "citizenId",
  "name",
  "position",
  "type",
  "dateReceive",
  "date",
  "employeeType",
  "section",
  "page",
  "number",
  "vatnumber",
  "datepay",
  "typepay",
  "address",
]);

/** function เรียกรอบการเสนอขอพระราชทานเครื่องราช*/
async function fecthRound() {
  showLoader();
  await http
    .get(config.API.noteround(), { params: { path: "RECORD" } })
    .then(async (res) => {
      let data = res.data.result;
      if (data.length !== 0) {
        selectRoundOption.value = data.map((e: ResponseRound) => ({
          name: "รอบการเสนอขอพระราชทานเครื่องราชฯ ปี" + "  " + (e.year + 543),
          id: e.id,
        }));
        selectRound.value = data[0].id;
        await Promise.all([fecthInsignia(), fecthInsigniaType()]);
      } else {
        hideLoader();
      }
    })
    .catch((err) => {
      messageError($q, err);
      hideLoader();
    });
}

/** function เรียกประเภทเครื่องราช*/
async function fecthInsignia() {
  await http
    .get(config.API.insigniaOrg)
    .then(async (res) => {
      let data = await res.data.result;
      DataStore.fetchDatainsignia(data);
    })
    .catch((err) => {
      messageError($q, err);
    });
}

/** function เรียกระดับเครื่องราช*/
async function fecthInsigniaType() {
  await http(config.API.insigniaTypeOrg)
    .then(async (res) => {
      let data = await res.data.result;
      DataStore.fetchDatainsigniaType(data);
      tab.value = DataStore.insigniaType[0].name;
      loadView.value = true;
    })
    .catch((err) => {
      messageError($q, err);
    });
}

/** function เลือกประเภทเครื่องราช*/
function selectorInsignia() {
  fecthlistInsignia();
}

/**
 *  function เลือกรอบการเสนอขอ
 * @param round รอบการเสนอขอ
 */
function selectorRound(round: string) {
  if (round) {
    selectRound.value = round;
  }
  fecthlistInsignia();
}

/** function เรียกรายชื่อบันทึกผลการได้รับพระราชทานเครื่องราชอิสริยาภรณ์/การจ่ายใบกำกับ */
async function fecthlistInsignia() {
  showLoader();
  let data = {
    insigniaTypeId: tab.value,
    insigniaNoteId: selectRound.value,
    insigniaId: DataStore.insignia,
  };
  await http
    .post(config.API.noteSearch(), data)
    .then(async (res) => {
      let data = await res.data.result;
      await DataStore.fetchlistinsignia(data);
      rowsMain.value = DataStore.rows;
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 * function uploadFile
 * @param event file
 * @param action  typepreview
 */
function uploadFile(event: any, action: string) {
  if (selectRound.value !== undefined) {
    let id = selectRound.value;
    dialogConfirm($q, () => {
      showLoader();
      const formdata = new FormData();
      formdata.append("file", event);
      http
        .put(config.API.uploadfileInsignia(action, id), formdata)
        .then(async () => {
          await fecthlistInsignia();
          if (action === "receice") {
            fileResult.value = null;
          } else if (action === "invoice") {
            fileinvoice.value = null;
          }

          await success($q, "อัพโหลดไฟล์สำเร็จ");
          modelPerview.value = false;
        })
        .catch((err) => {
          messageError($q, err);
          hideLoader();
        });
    }),
      "ยืนยันการบันทึกรายการข้อมูล",
      "ต้องการยืนยันรายการข้อมูลนี้หรื้อไม่ ?";
  }
}

/** function ปิด popup ทั้งหมด*/
function close() {
  modal.value = false;
  ModalDialog.value = false;
}

/** function เปิด popup บันทึกผล เพิ่มคน*/
function addData() {
  modal.value = true;
  action.value = "addData";
}

/** function  เปิด popup บันทึกผล แก้ไขข้อมูล*/
function editData(data: DataPerson) {
  personId.value = data.id;
  profileType.value = data.profileType;
  action.value = "editData";
  modal.value = true;
}

/** ข้อมูล ไฟล์*/
const modelPerview = ref<boolean>(false);
const filterPreview = ref<string>("");
const rowspreview = ref<any[]>([]);
const rowspreviewMain = ref<any[]>([]);

const typepreview = ref<string>("");
const fileInsignia = ref<any>(null);

/**
 * function แสดง fileupload
 * @param event  ไฟล
 * @param actionType  ประเภทไฟล์ receice,invoice
 */
function perviewfile(event: any, actionType: string) {
  showLoader();
  typepreview.value = actionType;
  fileInsignia.value = event;
  if (selectRound.value !== undefined) {
    let id = selectRound.value.toString();
    const formdata = new FormData();
    formdata.append("file", event);
    http
      .put(config.API.previewfileInsignia(actionType, id), formdata)
      .then((res) => {
        let data = res.data.result;
        rowspreview.value = data.map((e: any) => ({
          id: e.id,
          citizenId: e.citizenId,
          prefix: e.prefix,
          position: e.position,
          status: DataStore.status(e.status),
          dateReceive: date2Thai(e.dateReceive),
          name: e.fullName,
          type: e.requestInsignia,
          employeeType: DataStore.profileType(e.profileType),
          profileType: e.profileType,
          date: date2Thai(e.date),
          volumeNo: e.volumeNo,
          section: e.section,
          page: e.page,
          number: e.no,
          vatnumber: e.number,
          datepay: date2Thai(e.datePayment),
          typepay: e.typePayment,
          address: e.address,
        }));

        rowspreviewMain.value = rowspreview.value;
        modelPerview.value = true;
      })
      .catch((err) => {
        messageError($q, err);
      })
      .finally(() => {
        hideLoader();
      });
  }
}

function closeDialogPerview() {
  modelPerview.value = false;
  filterPreview.value = "";
  rowspreview.value = [];
  rowspreviewMain.value = [];
}

/**
 * function เปิด popup รับ-คืนเครื่องราชฯ
 * @param data ข้อมูลที่ต้องการแก่้ไข
 *
 */
function OpenModal(data: DataPerson) {
  dataModal.value = data;
  ModalDialog.value = true;
  dateCheckReceive.value = data.dateReceiveInsignia;
  dateCheckReturn.value = data.dateReturnInsignia;
  personId.value = data.id;
}

/**
 * function ค้นหาข้อมูล option
 * @param val คำค้นหา
 * @param update function
 * @param name ชื่อ selec
 */
function filterSelector(val: string, update: Function, name: string) {
  update(() => {
    const needle = val.toLowerCase();
    if (name === "insigniaTypeFilter") {
      DataStore.insignia = val ? (null as any) : DataStore.insignia;
      insigniaTypeFilter.value = insigniaTypeOption.value.filter(
        (v: OptionData) => v.name.toLowerCase().indexOf(needle) > -1
      );
    } else if (name === "filterInvoice") {
      DataStore.invoiceType = val ? "" : DataStore.invoiceType;
      filterInvoice.value = DataStore.invoiceTypeop.filter(
        (v: OptionData) => v.name.toLowerCase().indexOf(needle) > -1
      );
    }
    // else if (name === "filterEmployee") {
    //   DataStore.employeeClass = val ? "" : DataStore.employeeClass;
    //   filterEmployee.value = DataStore.employeeClassOps.filter(
    //     (v: OptionData) => v.name.toLowerCase().indexOf(needle) > -1
    //   );
    // }
  });
}

/**
 * function clearfilter เครื่องราช
 * @param name ชื่อ selec
 */
function clearInsigniaFilters(name: string) {
  if (name === "insigniaTypeFilter") {
    DataStore.insignia = "";
    insigniaTypeFilter.value = insigniaTypeOption.value;
  } else if (name === "filterInvoice") {
    DataStore.invoiceType = "all";
    filterInvoice.value = DataStore.invoiceTypeop;
  } else if (name === "filterEmployee") {
    // DataStore.employeeClass = "all";
    filterEmployee.value = DataStore.employeeClassOps;
  }
}

const paging = ref<boolean>(true);
const pagination = ref({
  sortBy: "name",
  descending: false,
  page: 1,
  rowsPerPage: 10,
});
const paginationLabel = (start: number, end: number, total: number) => {
  if (paging.value == true) return " " + start + "-" + end + " ใน " + total;
  else return start + "-" + end + " ใน " + total;
};

function serchDataTable() {
  DataStore.rows = onSearchDataTable(
    filter.value,
    rowsMain.value,
    columns.value ? columns.value : []
  );
}

function serchDataTableDailog() {
  rowspreview.value = onSearchDataTable(
    filterPreview.value,
    rowspreviewMain.value,
    columns.value ? columns.value : []
  );
}

const modalPersonal = ref<boolean>(false); // popup ทะเบียนประวัติ
/**
 *  function redirect to ทะเบียนประวัติ
 * @param id profileId
 */
function viewRegistry(id: string, type: string) {
  modalPersonal.value = true;
  personId.value = id;
  profileType.value = type;
}

function updatemodalPersonal(modal: boolean) {
  modalPersonal.value = modal;
}

/**
 * callback function จำทำงานเมื่อ tab มีการเปลี่ยนแปลง
 */
watch(tab, () => {
  if (tab.value !== "doc") {
    DataStore.rows = [];
    rowsMain.value = [];
    DataStore.insignia = "";
    fecthlistInsignia();
    insigniaTypeOption.value = DataStore.insigniaOp.filter(
      (e: any) => e.insigniaType == tab.value || e.name == "ทั้งหมด"
    );
    insigniaTypeFilter.value = insigniaTypeOption.value;
  }
});

/** hook*/
onMounted(() => {
  fecthRound();
});
</script>

<template>
  <div class="toptitle text-dark col-12 row items-center">
    บันทึกผลการได้รับพระราชทานเครื่องราชอิสริยาภรณ์/การจ่ายใบกำกับ
  </div>

  <q-card
    flat
    bordered
    class="col-12 q-my-md q-mt-sm rounded-borders"
    v-if="loadView == true"
  >
    <div class="bg-grey-1 col-12 row items-center">
      <div class="q-pl-md q-pr-sm text-weight-medium text-grey-7">รอบ</div>
      <div>
        <q-select
          hide-bottom-space
          borderless
          dense
          lazy-rules
          emit-value
          map-options
          options-dense
          option-label="name"
          option-value="id"
          v-model="selectRound"
          :options="selectRoundOption"
          use-input
          input-debounce="0"
          input-class="text-bold text-grey"
          @update:model-value="selectorRound(selectRound)"
        >
        </q-select>
      </div>
    </div>
    <q-separator />
    <q-tabs
      dense
      v-model="tab"
      align="left"
      class="bg-white text-grey"
      active-color="primary"
      indicator-color="primary"
    >
      <div v-for="item in DataStore.insigniaType">
        <q-tab :name="item.name" :label="item.label" />
      </div>

      <q-tab name="doc" label="เอกสารอ้างอิง" />
    </q-tabs>
    <q-separator />
    <q-tab-panels v-model="tab" animated>
      <q-tab-panel
        v-for="item in DataStore.insigniaType"
        :key="item.name"
        :name="item.name"
        class="q-pa-none"
      >
        <div class="q-pa-md">
          <q-card
            bordered
            class="col-12 q-mb-sm q-pa-sm"
            v-if="checkPermission($route)?.attrIsCreate"
          >
            <div class="row col-12 q-col-gutter-x-xs">
              <div class="col-xs-12 col-sm-6 row no-wrap q-col-gutter-x-xs">
                <q-file
                  dense
                  clearable
                  outlined
                  v-model="fileResult"
                  label="บันทึกผลการได้รับพระราชทานเครื่องราชอิสริยาภรณ์"
                  accept=".xlsx"
                  class="full-width"
                >
                  <template v-slot:prepend>
                    <q-icon name="attach_file" color="primary" />
                  </template>
                  <q-tooltip
                    >อัพโหลดไฟล์บันทึกผลการได้รับพระราชทานเครื่องราชอิสริยาภรณ์</q-tooltip
                  >
                </q-file>
                <div v-if="fileResult !== null">
                  <q-btn
                    size="12px"
                    flat
                    class="bg-teal-1 fit"
                    color="primary"
                    icon="mdi-upload"
                    @click="perviewfile(fileResult, 'receice')"
                  >
                    <q-tooltip
                      >อัพโหลดไฟล์บันทึกผลการได้รับพระราชทานเครื่องราชอิสริยาภรณ์</q-tooltip
                    >
                  </q-btn>
                </div>
              </div>
              <div class="col-xs-12 col-sm-6 row no-wrap q-col-gutter-x-xs">
                <q-file
                  dense
                  clearable
                  outlined
                  v-model="fileinvoice"
                  label="บันทึกผลการจ่ายใบกำกับ"
                  accept=".xlsx"
                  class="full-width"
                >
                  <template v-slot:prepend>
                    <q-icon name="attach_file" color="primary" />
                  </template>
                  <q-tooltip>อัพโหลดไฟล์บันทึกผลการจ่ายใบกำกับ</q-tooltip>
                </q-file>
                <div v-if="fileinvoice !== null">
                  <q-btn
                    size="12px"
                    flat
                    color="primary"
                    class="bg-teal-1 fit"
                    icon="mdi-upload"
                    @click="perviewfile(fileinvoice, 'invoice')"
                  >
                    <q-tooltip>อัพโหลดไฟล์บันทึกผลการจ่ายใบกำกับ</q-tooltip>
                  </q-btn>
                </div>
              </div>
            </div>
          </q-card>
          <div class="row col-12 q-pb-sm q-col-gutter-xs">
            <q-select
              v-model="DataStore.insignia"
              dense
              outlined
              lazy-rules
              hide-bottom-space
              :label="`${'เครื่องราชฯ'}`"
              emit-value
              map-options
              use-input
              option-label="name"
              :options="insigniaTypeFilter"
              option-value="id"
              :readonly="false"
              :borderless="false"
              style="width: 300px"
              @update:model-value="selectorInsignia"
              @filter="(inputValue:string,
                      doneFn:Function) => filterSelector(inputValue, doneFn,'insigniaTypeFilter'
                      ) "
            >
              <template v-if="DataStore.insignia" v-slot:append>
                <q-icon
                  name="cancel"
                  @click.stop.prevent="
                    clearInsigniaFilters('insigniaTypeFilter'),
                      selectorInsignia()
                  "
                  class="cursor-pointer"
                />
              </template>
              <template v-slot:no-option>
                <q-item>
                  <q-item-section class="text-grey">
                    ไม่มีข้อมูล
                  </q-item-section>
                </q-item>
              </template>
            </q-select>
            <q-space />
            <div class="items-center" style="display: flex">
              <!-- ค้นหาข้อความใน table -->
              <q-input
                standout
                dense
                v-model="filter"
                ref="filterRef"
                outlined
                placeholder="ค้นหา"
                style="max-width: 200px"
                class="q-ml-sm"
                @keydown.enter.prevent="serchDataTable"
              >
                <template v-slot:append>
                  <q-icon name="search" />
                </template>
              </q-input>
              <!-- แสดงคอลัมน์ใน table -->
              <q-select
                v-model="visibleColumns"
                :display-value="$q.lang.table.columns"
                multiple
                outlined
                dense
                :options="columns"
                options-dense
                option-value="name"
                map-options
                emit-value
                style="min-width: 140px"
                class="gt-xs q-ml-sm"
              />
            </div>
          </div>
          <div class="row col-12 q-mb-sm q-col-gutter-xs">
            <q-select
              v-model="DataStore.invoiceType"
              dense
              outlined
              lazy-rules
              hide-bottom-space
              :label="`${'ใบกำกับ'}`"
              emit-value
              map-options
              use-input
              option-label="name"
              :options="filterInvoice"
              option-value="id"
              :readonly="false"
              :borderless="false"
              style="width: 250px"
              @update:model-value="
                DataStore.searchData(
                  DataStore.invoiceType,
                  DataStore.employeeClass
                )
              "
              @filter="(inputValue:string,
                      doneFn:Function) => filterSelector(inputValue, doneFn,'filterInvoice'
                      ) "
            >
              <template v-if="DataStore.invoiceType !== 'all'" v-slot:append>
                <q-icon
                  name="cancel"
                  @click.stop.prevent="
                    clearInsigniaFilters('filterInvoice'),
                      DataStore.searchData(
                        DataStore.invoiceType,
                        DataStore.employeeClass
                      )
                  "
                  class="cursor-pointer"
                />
              </template>
              <template v-slot:no-option>
                <q-item>
                  <q-item-section class="text-grey">
                    ไม่มีข้อมูล
                  </q-item-section>
                </q-item>
              </template>
            </q-select>
            <!-- <q-select
              v-model="DataStore.employeeClass"
              dense
              outlined
              lazy-rules
              hide-bottom-space
              :label="`${'ประเภทตำแหน่ง'}`"
              emit-value
              map-options
              use-input
              option-label="name"
              :options="filterEmployee"
              option-value="id"
              :readonly="false"
              :borderless="false"
              style="width: 280px"
              @update:model-value="
                DataStore.searchData(
                  DataStore.invoiceType,
                  DataStore.employeeClass
                )
              "
              @filter="(inputValue:string,
                    doneFn:Function) => filterSelector(inputValue, doneFn,'filterEmployee'
                    ) "
            >
              <template v-if="DataStore.employeeClass !== 'all'" v-slot:append>
                <q-icon
                  name="cancel"
                  @click.stop.prevent="
                    clearInsigniaFilters('filterEmployee'),
                      DataStore.searchData(
                        DataStore.invoiceType,
                        DataStore.employeeClass
                      )
                  "
                  class="cursor-pointer"
                />
              </template>
              <template v-slot:no-option>
                <q-item>
                  <q-item-section class="text-grey">
                    ไม่มีข้อมูล
                  </q-item-section>
                </q-item>
              </template>
            </q-select> -->
            <div>
              <q-btn
                v-if="checkPermission($route)?.attrIsCreate"
                @click="addData()"
                flat
                round
                color="primary"
                icon="mdi-plus"
              >
                <q-tooltip>เพิ่ม</q-tooltip>
              </q-btn>
            </div>
          </div>
          <d-table
            :rows="DataStore.rows"
            :columns="columns"
            :visible-columns="visibleColumns"
            row-key="name"
            :pagination-label="paginationLabel"
            v-model:pagination="pagination"
          >
            <template v-slot:header="props">
              <q-tr :props="props">
                <q-th auto-width></q-th>
                <q-th v-for="col in props.cols" :key="col.name" :props="props">
                  <span class="text-weight-medium">{{ col.label }}</span>
                </q-th>
              </q-tr>
            </template>
            <template v-slot:body="props">
              <q-tr :props="props">
                <q-td auto-width>
                  <!-- ดูข้อมูลทะเบียนประวัติ -->
                  <q-btn
                    v-if="
                      checkPermission($route)?.attrIsGet && props.row.profileId
                    "
                    flat
                    round
                    dense
                    icon="info"
                    color="info"
                    @click.stop="
                      viewRegistry(props.row.profileId, props.row.profileType)
                    "
                  >
                    <q-tooltip>ดูข้อมูลทะเบียนประวัติ</q-tooltip>
                  </q-btn>

                  <q-btn
                    v-if="
                      checkPermission($route)?.attrIsGet &&
                      checkPermission($route)?.attrIsUpdate
                    "
                    flat
                    round
                    dense
                    icon="edit"
                    color="edit"
                    @click.stop="editData(props.row)"
                  >
                    <q-tooltip> แก้ไขข้อมูล</q-tooltip>
                  </q-btn>

                  <q-btn
                    v-if="
                      checkPermission($route)?.attrIsGet &&
                      checkPermission($route)?.attrIsUpdate &&
                      props.row.statusMain === 'DONE'
                    "
                    flat
                    round
                    dense
                    icon="mdi-information-outline"
                    color="blue"
                    @click.stop="OpenModal(props.row)"
                  >
                    <q-tooltip> รับ-คืนเครื่องราชฯ</q-tooltip>
                  </q-btn>
                </q-td>

                <q-td v-for="col in props.cols" :key="col.name" :props="props">
                  <div v-if="col.name == 'no'">
                    {{ props.rowIndex + 1 }}
                  </div>

                  <div v-else>
                    {{ col.value ? col.value : "-" }}
                  </div>
                </q-td>
              </q-tr>
            </template>
          </d-table>
        </div>
      </q-tab-panel>
      <q-tab-panel name="doc" class="q-pa-none">
        <fileUploadview :roundId="selectRound" />
      </q-tab-panel>
    </q-tab-panels>
  </q-card>

  <q-card v-else>
    <div class="q-pa-md q-gutter-sm">
      <q-banner inline-actions rounded class="bg-grey-1 text-center">
        ไม่มีข้อมูลรอบการเสนอขอพระราชทานเครื่องราชอิสริยาภรณ์
      </q-banner>
    </div>
  </q-card>

  <!-- รับ-คืนเครื่องราชฯ -->
  <Dialogbody
    :modal="ModalDialog"
    :close="close"
    :date-check-receive="dateCheckReceive"
    :date-check-return="dateCheckReturn"
    :data-modal="dataModal"
    :person-id="personId"
    :fecthlist-insignia="fecthlistInsignia"
  />

  <!-- บันทึกผล -->
  <DialogForm
    :modal="modal"
    :close="close"
    :round-id="selectRound"
    :action="action"
    :person-id="personId"
    profile-type="officer"
    :fecthlist-insignia="fecthlistInsignia"
  />

  <!-- ยืนยันรายการข้อมูล -->
  <q-dialog v-model="modelPerview" persistent>
    <q-card style="min-width: 80%">
      <DialogHeader tittle="ยืนยันรายการข้อมูล" :close="closeDialogPerview" />
      <q-separator />
      <q-card-section>
        <div class="row col-12 q-col-gutter-sm">
          <div class="row col-12">
            <q-space />
            <div class="row q-col-gutter-sm">
              <q-input
                dense
                outlined
                v-model="filterPreview"
                label="ค้นหา"
                @keydown.enter.prevent="serchDataTableDailog"
              >
                <template v-slot:append>
                  <q-icon name="search" />
                </template>
              </q-input>

              <q-select
                v-model="visibleColumns"
                multiple
                outlined
                dense
                options-dense
                :display-value="$q.lang.table.columns"
                emit-value
                map-options
                :options="columns"
                option-value="name"
                style="min-width: 140px"
              />
            </div>
          </div>
          <div class="col-12">
            <d-table
              :rows="rowspreview"
              :columns="columns"
              :visible-columns="visibleColumns"
              row-key="name"
            >
              <template v-slot:body-cell="props">
                <q-td :props="props">
                  <div v-if="props.col.name == 'no'">
                    {{ props.rowIndex + 1 }}
                  </div>
                  <div v-else>
                    {{ props.value ? props.value : "-" }}
                  </div>
                </q-td>
              </template>
            </d-table>
          </div>
        </div>
      </q-card-section>
      <q-separator />

      <q-card-actions align="right">
        <q-btn
          unelevated
          color="public"
          label="บันทึก"
          @click="uploadFile(fileInsignia, typepreview)"
        />
      </q-card-actions>
    </q-card>
  </q-dialog>

  <PopupPersonal
    :modal="modalPersonal"
    :id="personId"
    :type="profileType"
    @update:modal="updatemodalPersonal"
  />
</template>
<style lang="scss" scoped>
.arrow {
  transition: transform 0.5s;
}

.arrow-active {
  transition: transform 0.5s;
  transform: rotate(-90deg);
}

.bg-base {
  background-color: #f3f3f398;
}

.v-enter-active,
.v-leave-active {
  transition: opacity 0.5s ease;
}

.v-enter-from,
.v-leave-to {
  opacity: 0;
}

.flexsave {
  display: flex;
  justify-content: flex-end;
}
</style>
